Attribute VB_Name = "Error_Routines"
'/*
'WordBastard - rich text editor
'Error_Routines.bas - error logging routines
'Copyright  (C) 1998-2000 Hugues Johnson
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
'the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'*/


'/* 10/8/98 A.D.
' Added these to prevent the occasional infinite loop.
'*/
Private lLastError As Long
Private iLastErrorCount As Integer
Public Sub ErrorHandler(ByRef objErr As Object, Optional moduleName As String, Optional Variables As String)
    Dim fp As Integer
        
    If (IsMissing(module)) Then moduleName = "unknown"
    If (IsMissing(Variables)) Then Variables = ""
    
    'Log Error to File
    fp = FreeFile
    If (Right$(App.Path, 1) = "\") Then
        Open App.Path & "Error.log" For Append As #fp
    Else
        Open App.Path & "\Error.log" For Append As #fp
    End If
    Print #fp, Date & " " & Time
    Print #fp, "Error Number=" & Trim$(Str$(objErr.Number))
    Print #fp, "Error Description=" & Trim$(objErr.Description)
    Print #fp, "Error Source=" & Trim$(objErr.Source)
    Print #fp, "Module=" & Trim$(module)
    Print #fp, ""
    Print #fp, "Additional Data"
    Print #fp, "-----------------"
    Print #fp, Variables
    Print #fp, "_____________________________________________________"
    Close #fp

    '/* This little routine prevents the occasional infinite loop. */
    If (objErr.Number = lLastError) Then
        iLastErrorCount = iLastErrorCount + 1
        If (iLastErrorCount > 10) Then
            MsgBox "A fatal error has occured", vbCritical + vbOKOnly, App.Title
            End
        End If
    Else
        iLastErrorCount = 0
        lLastError = objErr.Number
    End If

    '/* clear the error */
    Err.Clear

End Sub
