Attribute VB_Name = "Main_Routine"
'/*
'WordBastard - rich text editor
'Main.bas - entry point for WordBastard
'Copyright  (C) 1998-2000 Hugues Johnson
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
'the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'*/

Public Sub GetFormSettings(frm As Form)
    Dim q As String
    
    With frm
        q = GetSetting("Layout", "Left")
        .Left = Int(Val(q))
        q = GetSetting("Layout", "Top")
        .Top = Int(Val(q))
        q = GetSetting("Layout", "WindowState")
        .WindowState = Int(Val(q))
    End With

End Sub


Public Sub Main()

    Load frm_Splash
    frm_Splash.Show
    frm_Splash.Refresh
        
    If Not (IniFileExists) Then
        CreateInitialFile
    End If
    
    If Not (PlayListDataExists) Then
        CreateInitialPlayList
    End If
    
    Load frm_Main
    
    GetFormSettings frm_Main
    GetRTFSettings frm_Main.rtf_File
    
    frm_Main.tlb_File.Visible = Int(Val(GetSetting("Layout", "Toolbar")))
    frm_Main.tlb_Format.Visible = Int(Val(GetSetting("Layout", "FormatBar")))
    frm_Main.tlb_MM.Visible = Int(Val(GetSetting("Layout", "MCIBar")))
    
    Unload frm_Splash
    frm_Main.Show
    
    If (Command <> vbNullString) Then
        frm_Main.rtf_File.LoadFile Str$(Command)
    End If
   
End Sub



Public Function IniFileExists() As Boolean
    Dim fp As Integer
    
    On Error Resume Next
    
    fp = FreeFile
    
    If (Right$(App.Path, 1) = "\") Then
        Open App.Path & "WordBastard.ini" For Input As #fp
    Else
        Open App.Path & "\WordBastard.ini" For Input As #fp
    End If
    
    If (Err = 0) Then
        IniFileExists = True
    Else
        IniFileExists = False
        Err.Clear
    End If

    Close #fp

End Function

Public Sub GetRTFSettings(rtf As RichTextBox)
    Dim q As String
    
    With rtf
        q = GetSetting("RTF", "SelFontName")
        .SelFontName = Trim$(q)
        q = GetSetting("RTF", "SelFontSize")
        .SelFontSize = Int(Val(q))
        q = GetSetting("RTF", "SelColor")
        .SelColor = CLng(q)
        q = GetSetting("RTF", "BackColor")
        .BackColor = CLng(q)
    End With

End Sub


