Attribute VB_Name = "Process_List_95"
'/*
'WordBastard - rich text editor
'Process_List_95.bas - create process list under Win9x
'Copyright  (C) 1998-2000 Hugues Johnson
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
'the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'*/

Option Explicit

Public Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal dwFlags As Long, ByVal th32ProcessID As Long) As Long
Public Declare Function Process32First Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Public Declare Function Process32Next Lib "kernel32" (ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long
Public Declare Function Module32First Lib "kernel32" (ByVal hSnapshot As Long, lpme As MODULEENTRY32) As Long
Public Declare Function Module32Next Lib "kernel32" (ByVal hSnapshot As Long, lpme As MODULEENTRY32) As Long
    
Private Const MAX_MODULE_NAME32 As Integer = 255
Private Const MAX_MODULE_NAME32plus As Integer = MAX_MODULE_NAME32 + 1
Private Const MAX_PATH = 260
Public Const TH32CS_SNAPPROCESS = &H2&
Public Const TH32CS_SNAPMODULE = &H8&

Public Type PROCESSENTRY32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwFlags As Long
    szExeFile As String * MAX_PATH
End Type

Public Type MODULEENTRY32
    dwSize As Long
    th32ModuleID As Long
    th32ProcessID As Long
    GlblcntUsage As Long
    ProccntUsage As Long
    modBaseAddr As Long
    modBaseSize As Long
    hModule As Long
    szModule As String * MAX_MODULE_NAME32plus
    szExePath As String * MAX_PATH
End Type

Public Function StrZToStr(s As String) As String
    
    StrZToStr = Left$(s, Len(s) - 1)

End Function

Public Function FillProcessList95(tree As TreeView) As Long
    Dim ReturnID As Long
    Dim hSnapProcess As Long
    Dim hSnapModule As Long
    Dim proc As PROCESSENTRY32
    Dim module As MODULEENTRY32
    Dim ProcessCount As Integer
    Dim ProcessName As String
    Dim ChildProcessName  As String
    Dim nd As Node

    tree.Nodes.Clear
    
    hSnapProcess = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
    
    If (hSnapProcess = hNull) Then
        FillProcessList95 = 0
    Else
        proc.dwSize = Len(proc)
        ReturnID = Process32First(hSnapProcess, proc)
        Do While ReturnID
            ProcessName = StrZToStr(proc.szExeFile)
            Set nd = tree.Nodes.Add(, , ProcessName, ProcessName)
            ProcessCount = ProcessCount + 1
            hSnapModule = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, proc.th32ProcessID)
            If Not (hSnapModule = hNull) Then
                module.dwSize = LenB(module) - 1
                ReturnID = Module32First(hSnapModule, module)
                Do While ReturnID
                    ChildProcessName = StrZToStr(module.szModule)
                    If (Trim$(ChildProcessName) <> "") Then
                        Set nd = tree.Nodes.Add(ProcessName, tvwChild, , ChildProcessName)
                    End If
                    ReturnID = Module32Next(hSnapModule, module)
                Loop
            End If
            CloseHandle hSnapModule
            ReturnID = Process32Next(hSnapProcess, proc)
        Loop
        CloseHandle hSnapProcess
        FillProcessList95 = ProcessCount
    End If

End Function
